; ----------------------------------------------------------------------------
; XBC AutoCopy v1.2
; Author: iRockHard
; Function: Automates the Copy of an Xbox360 Game
; ----------------------------------------------------------------------------

; ----------------------------------------------------------------------------
; Verify "Settings.ini" file
; ----------------------------------------------------------------------------

If 	FileExists("Settings.ini") = 0 Then  ; Make sure Settings.ini exists
    MsgBox(0, "Error", "The ""Settings.ini"" file does not exist.")
	Exit
EndIf

; Make sure individual keys are valid
If 	IniRead("Settings.ini", "Settings", "SHOW_MESSAGE", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the SHOW_MESSAGE key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "MESSAGE1", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the MESSAGE1 key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "MESSAGE2", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the MESSAGE2 key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "MESSAGE3", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the MESSAGE3 key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "XBC", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the XBC key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "READER", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the READER key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "BURNER", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the BURNER key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "FOLDER", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the FOLDER key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "BURN_ENGINE", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the BURN_ENGINE key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "BURN_SPEED", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the BURN_SPEED key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "SOUND", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the SOUND key in ""Settings.ini"" file.")
	Exit
ElseIf IniRead("Settings.ini", "Settings", "DELETE", "NotFound") = "NotFound" Then
    MsgBox(0, "Error", "Unable to read the DELETE key in ""Settings.ini"" file.")
	Exit
Else
	; Import settings from Settings.ini file
	$show_message = IniRead("Settings.ini", "Settings", "SHOW_MESSAGE", "NotFound")
	$message1 = IniRead("Settings.ini", "Settings", "MESSAGE1", "NotFound")
	$message2 = IniRead("Settings.ini", "Settings", "MESSAGE2", "NotFound")
	$message3 = IniRead("Settings.ini", "Settings", "MESSAGE3", "NotFound")
	$xbc = IniRead("Settings.ini", "Settings", "XBC", "NotFound")
	$reader = IniRead("Settings.ini", "Settings", "READER", "NotFound")
	$folder = IniRead("Settings.ini", "Settings", "FOLDER", "NotFound")
	$burner = IniRead("Settings.ini", "Settings", "BURNER", "NotFound")
	$burn_engine = IniRead("Settings.ini", "Settings", "BURN_ENGINE", "NotFound")
	$burn_speed = IniRead("Settings.ini", "Settings", "BURN_SPEED", "NotFound")
	$sound = IniRead("Settings.ini", "Settings", "SOUND", "NotFound")
	$delete = IniRead("Settings.ini", "Settings", "DELETE", "NotFound")
EndIf	

; Set script options
$files = @ScriptDir & "\Files\"
TraySetIcon ($files & "AutoCopy.ico") ; Changes the tray icon
Opt ("MouseCoordMode", 2)        ;1=absolute, 0=relative, 2=client
Opt ("WinTitleMatchMode", 2)     ;1=start, 2=subStr, 3=exact, 4=advanced


; ----------------------------------------------------------------------------
; Start Xbox Backup Creator
; ----------------------------------------------------------------------------
If $show_message = "On" Then ; Show instructional message if setting = On, Skip if = Off
	MsgBox (64, "AutoCopy Instructions:", $message1 & @CRLF & @CRLF & $message2 & @CRLF & @CRLF & $message3, 300)
EndIf

Run ($xbc) ; Run program

WinWait ("Xbox Backup Creator v", "") ; Wait for app
Sleep (3000) ; Wait 3 seconds
ControlCommand ("Xbox Backup Creator v", "", "[CLASS:ThunderRT6ComboBox; INSTANCE:6]", "SelectString", $reader) ; Select Reader
WinWait ("Xbox Backup Creator v", "Media Type: DVD-ROM") ; Wait to recognize the game disc
ControlClick ("Xbox Backup Creator v", "Media Type: DVD-ROM", "Complete Backup") ; Select Image Style (Complete Backup = 69, Current Partition = 70)
ControlClick ("Xbox Backup Creator v", "Media Type: DVD-ROM", "Start") ; Click Start to begin reading
WinWait ("Save image as", "")  ; Wait for file selection window
Send("Copy") ; Name the game files
Send ("{ENTER}") ; Click Save

; ----------------------------------------------------------------------------
; Overwrite old game files (named Copy) if they exist
; ----------------------------------------------------------------------------

Sleep (2000) ; Wait 2 seconds
Opt ("WinTitleMatchMode", 3)     ;1=start, 2=subStr, 3=exact, 4=advanced
If WinExists ("Xbox Backup Creator", "overwrite this file?") Then
	WinActivate ("Xbox Backup Creator", "overwrite this file?") ; Acknowledge overwrite pop
	ControlClick ("Xbox Backup Creator", "overwrite this file?", 1) ; Click OK	
EndIf

; ----------------------------------------------------------------------------
; Start Reading
; ----------------------------------------------------------------------------

Opt ("WinTitleMatchMode", 3)     ;1=start, 2=subStr, 3=exact, 4=advanced
While WinExists ("Xbox Backup Creator", "completed") = 0 ; Wait for completion
	If WinExists ("DVD Read Error", "" ) Then ; Abort if there's an error
		If $sound = "On" Then ; Alert if setting = On, Skip if = Off 
			SoundPlay ($files & "error.wav", 1) ; Play the Error.wav file
		EndIf
		Exit ; Abort
	EndIf
	If WinExists ("Xbox Backup Creator", "failed" ) Then ; Abort if there's an error
		If $sound = "On" Then ; Alert if setting = On, Skip if = Off 
			SoundPlay ($files & "error.wav", 1) ; Play the Error.wav file
		EndIf
		Exit ; Abort
	EndIf	
WEnd	
WinActivate ("Xbox Backup Creator", "completed" ) ; Acknowledge Reading Completed pop
Send ("{ENTER}")

Opt ("WinTitleMatchMode", 2)     ;1=start, 2=subStr, 3=exact, 4=advanced
Sleep (3000) ; Wait 3 seconds

; ----------------------------------------------------------------------------
; Reading Finished
; ----------------------------------------------------------------------------

WinWait ("Xbox Backup Creator v", "") ; Wait for main window
WinActivate ("Xbox Backup Creator v", "") ; Activate main window
ControlCommand ("Xbox Backup Creator v", "", "[CLASS:ThunderRT6ComboBox; INSTANCE:6]", "SelectString", $burner) ; Select Burner
Send("^{TAB}") ; Select the Write Tab
ControlClick ("Xbox Backup Creator v", "Media Type: DVD+R DL", $burn_engine) ; Select Burn Engine
ControlCommand ("Xbox Backup Creator v", "", "[CLASS:ThunderRT6ComboBox; INSTANCE:1]", "SelectString", $burn_speed) ; Select Burn Speed
ControlClick ("Xbox Backup Creator v", "Media Type: DVD+R DL", "Start") ; Click Start to begin writing

WinWait ("Select DVD file", "")  ; Wait for file selection window
WinActivate ("Select DVD file", "")  ; Activate file selection window
Send("+{TAB}") ; Highlight the newly newly created game file
Send("{DOWN}") ; Select the newly newly created game file
Send ("{ENTER}") ; Click Open

; ----------------------------------------------------------------------------
; Start Burning
; ----------------------------------------------------------------------------

Opt ("WinTitleMatchMode", 3)     ;1=start, 2=subStr, 3=exact, 4=advanced
WinWait ("Xbox Backup Creator", "Write") ; Wait for completion
	If WinExists ("Xbox Backup Creator", "completed") Then
		WinActivate ("Xbox Backup Creator", "completed") ; Acknowledge Burning Completed pop
		Send ("{ENTER}")
	Else
		If $sound = "On" Then ; Alert if setting = On, Skip if = Off 
			SoundPlay ($files & "error.wav", 1) ; Play the Error.wav file
		EndIf
		Exit ; Abort
	EndIf
Opt ("WinTitleMatchMode", 2)     ;1=start, 2=subStr, 3=exact, 4=advanced

; ----------------------------------------------------------------------------
; Burning Finshed
; ----------------------------------------------------------------------------

WinClose ("Xbox Backup Creator v", "") ; Close Xbox Backup Creator
	If $sound = "On" Then ; Alert if setting = On, Skip if = Off 
		SoundPlay ($files & "success.wav", 1) ; Play the Error.wav file
	EndIf
	If $delete = "Yes" Then ; Delete the game files if setting = Yes, Don't if = No 
		FileDelete ( $folder & "*.*") ; Delete the game files
	EndIf
Exit

; ----------------------------------------------------------------------------
; Process Completed!
; ----------------------------------------------------------------------------